// MP3_playerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MP3_player.h"
#include "MP3_playerDlg.h"

#include "fmod.h"
#include "fmodce.h"
#include "fmod_errors.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//declarations made by me
CString filePath;
CString err_mesg;
FSOUND_STREAM* song=NULL;

int song_time;	//this variable will store MP3 time in ms
int sec=0, min=0, hr = 0;

#define WM_SHOW_PLAYTIME WM_USER+400	//message timer ID used to present the MP3 remaining time
UINT_PTR TimerID;

// CMP3_playerDlg dialog

CMP3_playerDlg::CMP3_playerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMP3_playerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMP3_playerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_path, my_EditPath);
	DDX_Control(pDX, IDC_BUTTON_Play, my_Butt_Play);
	DDX_Control(pDX, IDC_BUTTON_Stop, my_Butt_Stop);
	DDX_Control(pDX, IDC_PROGRESS1, my_Progress_MP3progress);
	DDX_Control(pDX, IDC_EDIT_Errors, my_Edit_Errors);
	DDX_Control(pDX, IDC_BUTTON_Browse, my_Butt_Browse);
	DDX_Control(pDX, IDC_EDIT_time, my_Edit_Time);
}

BEGIN_MESSAGE_MAP(CMP3_playerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_Browse, &CMP3_playerDlg::OnBnClickedButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_Play, &CMP3_playerDlg::OnBnClickedButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_Stop, &CMP3_playerDlg::OnBnClickedButtonStop)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CMP3_playerDlg message handlers

BOOL CMP3_playerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	my_Butt_Play.EnableWindow(0);
	my_Butt_Stop.EnableWindow(0);

	my_Edit_Time.SetWindowTextW(_T("00:00:00"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMP3_playerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MP3_PLAYER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MP3_PLAYER_DIALOG));
	}
}
#endif

void CMP3_playerDlg::OnBnClickedButtonBrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog file(TRUE,L".mp3",NULL,OFN_HIDEREADONLY, _T("MP3 File (*.mp3)|*.mp3||"), NULL);
	
	if(file.DoModal() == IDOK) //check if a file is selected
	{
		filePath = file.GetPathName();			//get the path to the file
		my_EditPath.SetWindowTextW(filePath);	//show the mp3 file name and path in the edit box

		//I have a correct file selected => validate the MP3 function
		my_Butt_Play.EnableWindow(1);
		my_Butt_Stop.EnableWindow(1);
	}
}

void CMP3_playerDlg::OnBnClickedButtonPlay()
{
	// TODO: Add your control notification handler code here
	
	//FSOUND_Init must be use before each MP3 song
	FSOUND_Init(44100,32,0);
		err_mesg = FMOD_ErrorString(FSOUND_GetError());
		//AfxMessageBox (err_mesg,NULL, MB_OK);
		my_Edit_Errors.SetWindowTextW (err_mesg);

	song = FSOUND_Stream_Open(CStringA(filePath),FSOUND_MPEGACCURATE  ,0,0);

	if (song == 0)
		{
		err_mesg = FMOD_ErrorString(FSOUND_GetError());
		//AfxMessageBox (err,NULL, MB_OK);
		my_Edit_Errors.SetWindowTextW (err_mesg);
		return;	//no song selected - get out !
		}

	sec=0; min=0; hr = 0;
  
	FSOUND_Stream_Play (0, song); 
	song_time=FSOUND_Stream_GetLengthMs(song);	//mp3 length in ms
 
	//RETAILMSG(1, (TEXT("The song has a length of %d \n"), song_time));
	
	TimerID = SetTimer(WM_SHOW_PLAYTIME, 1000, NULL);	//create 
	
	my_Progress_MP3progress.SetPos(0);	//the progress bar start from 0;
	//set progress length equal with time of the MP3 in seconds
	my_Progress_MP3progress.SetRange(0, song_time/1000);
	my_Progress_MP3progress.SetStep(1);

	my_Butt_Play.EnableWindow(0);
	my_Butt_Stop.EnableWindow(1);
	my_Butt_Browse.EnableWindow(0);
}

void CMP3_playerDlg::OnBnClickedButtonStop()
{
	// TODO: Add your control notification handler code here

	my_Progress_MP3progress.SetPos(0);

	KillTimer(TimerID);	//kill the timer from the Windows Embedded Compact kernel

	my_Edit_Time.SetWindowTextW(_T("00:00:00"));
	sec=0; min=0; hr = 0;

	FSOUND_Stream_Close(song);
	FSOUND_Close();

	my_Butt_Play.EnableWindow(1);
	my_Butt_Stop.EnableWindow(0);
	my_Butt_Browse.EnableWindow(1);
}

void CMP3_playerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	FSOUND_Stream_Close(song);
	FSOUND_Close();

	KillTimer(TimerID);
}

void CMP3_playerDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnTimer(nIDEvent);

	if(nIDEvent == WM_SHOW_PLAYTIME)
		{
		CString time_format;
		
		//get the mp3 elapse time
		int current_time = FSOUND_Stream_GetTime(song)/1000;
		
		if(current_time < song_time/1000)
			{
			//count the time in hours:minutes:seconds
			sec++;
			if(sec == 60)
				{
					sec = 0;
					min += 1;
					if (min == 60)
						{
						min = 0;
						hr +=1;
						}
				}
		
			time_format.Format(_T("%2.2d:%2.2d:%2.2d"), hr, min, sec);
			my_Edit_Time.SetWindowTextW((time_format));
		
			my_Progress_MP3progress.StepIt();
			}
		else
			{
			KillTimer(TimerID);
			my_Progress_MP3progress.SetPos(0);

			FSOUND_Stream_Close(song);
			FSOUND_Close();

			sec = 0; min = 0; hr = 0;
			my_Edit_Time.SetWindowTextW(_T("00:00:00"));

			my_Butt_Play.EnableWindow(1);
			my_Butt_Stop.EnableWindow(0);
			my_Butt_Browse.EnableWindow(1);
			}
		}
}


